"{ Package: 'stx:libtool/smallsense' }"

SmallSenseParseNodeVisitor subclass:#SmallSenseFinder
	instanceVariableNames:'position match previous'
	classVariableNames:''
	poolDictionaries:''
	category:'SmallSense-Core'
!


!SmallSenseFinder methodsFor:'finding'!

findNodeIn: source tree: tree line: line column: col

    | sourceS |
    sourceS := source readStream.
    line - 1 timesRepeat:[
        (sourceS nextLine) isNil ifTrue:[
            "No such line"                                
            ^nil
        ].        
    ].
    ^self findNodeIn: source tree: tree position: sourceS position + col

    "Created: / 26-11-2011 / 15:33:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

findNodeIn: source tree: tree position: pos

    position := pos - 1.
    self visit: tree.
    ^SmallSensePosition node: match ? previous position: pos.

    "Created: / 26-11-2011 / 15:37:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseFinder methodsFor:'visiting'!

visit:anObject 

    anObject isNil ifTrue:[^self].

    (position > anObject endPosition) ifTrue:[
        previous := anObject.
        anObject acceptVisitor: self.
        ^self.
    ].

    (position between: anObject startPosition and: anObject endPosition) ifTrue:[
        match := anObject.
        anObject acceptVisitor: self.
    ].

    "Created: / 26-11-2011 / 15:40:07 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

visitStatementNode:anObject 

    self visit: anObject expression.
    self visit: anObject nextStatement.

    "Modified: / 25-07-2011 / 22:34:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Created: / 26-11-2011 / 15:40:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SmallSenseFinder class methodsFor:'documentation'!

version_SVN
    ^ '$Id: SmallSenseFinder.st 7823 2011-11-26 16:55:59Z vranyj1 $'
! !
